#         Script : SKooL v1.00 by David Proper (Dr. Nibble [DrN])
#                  Copyright 2002 Radical Computer Systems
#                             All Rights Reserved
#
#       Testing
#      Platforms : Linux 2.4.18   TCL v8.3
#                  Eggdrop v1.6.2
#                  Eggdrop v1.6.6
#            And : SunOS 5.8      TCL v8.3
#                  Eggdrop v1.5.4
#
#    Description : SKooL lets your bot run those lessons you find on
#                  most networks. It trys to make running them easy on
#                  the OPs. 
#
#        History : 09/04/2002 - First Release
#
#      Donations : https://www.paypal.com/xclick/business=rainbows%40stx.rr.com
# (If you don't have PayPal and want to donate, EMail me for an address.
#  Will take money or hardware/computer donations)
#
#   Future Plans : Fix Bugs. :)
#   <R33D33R> for questions and stuff
#             like a take-a-number for questions
#             /msg IRCd-Univ skool question <question here>
#   <R33D33R> make this class script work with netlink
#
# Author Contact :     Email - DProper@stx.rr.com
#                  Home Page - http://home.stx.rr.com/dproper
#       Homepage Direct Link - http://www.chaotix.net/~dproper
#                        IRC - Primary Nick: DrN
#                     UseNet - alt.irc.bots.eggdrop
# Support Channels: #RCS @UnderNet.Org
#                   #RCS @DALnet
#                   #RCS @EFnet
#                   #RCS @GalaxyNet
#                   #RCS @Choatix Addiction
#            Other channels - Check contact page for current list
#
#                Current contact information can be located at:
#                 http://www.chaotix.net/rcs/contact.html
#
# New TCL releases are sent to the following sites as soon as they're released:
#
# FTP Site                   | Directory                     
# ---------------------------+-------------------------------
# ftp.chaotix.net            | /pub/RCS
# ftp.eggheads.org           | Various
# ftp.realmweb.org           | /drn
#
# Chaotix.Net has returned. Web site and mailing list back online
#
#   Radical Computer Systems - http://www.chaotix.net/rcs/
# To subscribe to the RCS mailing list:
# http://www.chaotix.net/mailman/listinfo/rcs-list
#
#  Feel free to Email me any suggestions/bug reports/etc.
# 
# You are free to use this TCL/script as long as:
#  1) You don't remove or change author credit
#  2) You don't release it in modified form. (Only the original)
# 
# If you have a "too cool" modification, send it to me and it'll be
# included in the official release. (With your credit)
#
# Commands Added:
#  Where     F CMD          F CMD            F CMD           F CMD
#  -------   - ----------   - ------------   - -----------   - ----------
#  Public:   o !skool
#     MSG:   o skool
#     DCC:   o skool
#
# Public Matching: N/A
#

# SKOOL Commands:
#  LOAD filename      - This will load a lesson into the script
#  RUN [marker]       - This will start the loaded lesson. Start at marker 
#                       or beginning if no marker is given.
#  STOP               - This will abort a currentlly running lesson
#  PAUSE              - This will pause a running lesson
#  UNPAUSE            - This will unpause a running lesson
#  TOPIC              - This will display the topic of the currentlly 
#                       loaded lesson


# Commands for lesson file:
# !tag
# This sets a marker so you can continue a lesson in case of interuption
#  EX: !E12
#  This will display (E12) at the end of the enxt text line and allow you
#  to continue with:    !skool run E12
# P#
#  Pause for # seconds               EX: P15
# Mdata
#  Change channel modes to data      EX: M+m
# Wmsg
#  Send a message to all OPs         EX: WLesson paused 15 seconds.
# Ttopic
#  Change channel topic              EX: TToday's lesson: %topic%
# ;
#  Lines starting with a ; are ignored and not loaded.
# =topic
#  Set the lesson topic              EX: =MIRC Scripting 101
# Any text starting with a space is sent to the channel.

# Variables useable in lesson output:
#  %channel%            - Channel which lesson is taking place on
#  %nick%               - Nick of the person who started the lesson
#  %topic%              - Lesson topic as defined by the = command

if {[info exists skool_lesson]} {unset skool_lesson}


# Change the ! to whatever public trigger you want.
# If left as ! then the command is !skool
if {![info exists cmdchar_]} {set cmdchar_ "!"}

# Directory to find lesson files in (Put all the *.skl here)
set skool(data) "/home/eggdrop/scripts/rcs/school/"

# Default text output delay in seconds
set skool(delay) 3


# Variables used internally by script. Don't be an idiot and fuck with them.
set skool(ver) "v1.00.01"
set skool(run) 0
set skool(load) 0
set skool(timer) ""
set skool_lesson(max) 0
set skool_lesson(cur) 0

proc cmdchar { } {global cmdchar_; return $cmdchar_}


bind pub - [cmdchar]skool pub_skool
proc pub_skool {nick uhost hand chan rest} {
global skool
 set cmd [string toupper [lindex $rest 0]]
 set rest [lrange $rest 1 end]
 switch $cmd {
  "" {skool_out $nick $chan "Avaliable Commands: LOAD RUN STOP PAUSE UNPAUSE TOPIC"}
  "LOAD" {skool_load $chan $nick $rest}
  "RUN" {skool_run $chan $nick $rest}
  "STOP" {skool_stop $chan $nick $rest}
  "PAUSE" {skool_pause $chan $nick $rest}
  "UNPAUSE" {skool_unpause $chan $nick $rest}
  "TOPIC" {skool_topic $chan $nick $rest}
             }

 return 0
}

proc skool_topic {chan nick rest} {
global skool
 if {$skool(load) == 0} {skool_out $nick $chan "There is currently no lesson loaded."; return 0}
 skool_out $nick $chan "Currently loaded lesson is: $skool(topic)"
}

proc skool_unpause {chan nick rest} {
global skool
 if {$skool(run) == 0} {skool_out $nick $chan "There is no lesson running."; return 0}
 if {$skool(pause) == 0} {skool_out $nick $chan "lesson isn't currentlly paused."; return 0}
# skool_out $nick $chan "Resuming Lesson"
# if {[info exists skool(timer)]} {killutimer $skool(timer)}
 skool_out $nick $skool(chan) "Resuming Lesson"
 set skool(timer) [utimer $skool(delay) skool_teach]
 set skool(pause) 0
}

proc skool_pause {chan nick rest} {
global skool
 if {$skool(run) == 0} {skool_out $nick $chan "There is no lesson running."; return 0}
 if {$skool(pause) == 1} {skool_out $nick $chan "Lesson is allready paused."; return 0}
# skool_out $nick $chan "Pausing Lesson"
 if {[info exists skool(timer)]} {killutimer $skool(timer)}
 set skool(timer) ""
 set skool(pause) 1
 skool_out $nick $skool(chan) "Lesson Paused by $nick"
}

proc skool_stop {chan nick rest} {
global skool skool_lesson
 if {$skool(run) == 0} {skool_out $nick $chan "There is no lesson running."; return 0}
# skool_out $nick $chan "Aborting Lesson"
 if {[info exists skool(timer)]} {killutimer $skool(timer)}
 set skool(timer) ""
 set skool(run) 0
 set skool(cur) [expr $skool_lesson(max) + 1]
 skool_out $nick $skool(chan) "Lesson Aborted by $nick"
}

proc skool_run {chan nick rest} {
global skool skool_lesson
 if {$skool(run) == 1} {skool_out $nick $chan "There is currently a lesson running."; return 0}
 if {$skool(load) == 0} {skool_out $nick $chan "There is currently no lesson loaded. Can't teach if there's nothing to teach."; return 0}

 set skool_lesson(cur) 0
 
if {$rest != ""} {
 set sloop 0
 set sfound 0
 set rest [string toupper $rest]
 while {$sloop < $skool_lesson(max)} {
  incr sloop
  set line $skool_lesson($sloop)
  set cmd [string index $line 0]
  set line [string toupper [string range $line 1 end]]
  if {($cmd == "!") && ($rest == $line)} {
                                          set skool_lesson(cur) [expr $sloop - 1]
                                          set sfound 1
                                          skool_out $nick $chan "Found Marker $rest - Continuing"
                                         }
                                     }
 if {$sfound == 0} {skool_out $nick $chan "Sorry, can't find $rest marker"
                    return 0}
                 }
 set skool(chan) $chan
 set skool(started) $nick
 set skool(run) 1
 set skool(pause) 0
 set skool(timer) [utimer $skool(delay) skool_teach]
}

proc skool_teach {} {
global skool skool_lesson
 set chan $skool(chan)
 set delay $skool(delay)

if {$skool_lesson(cur) >= $skool_lesson(max)} {
 set skool(timer) ""
 set skool(run) 0
# Do NOT remove this information block. If you want it gone, then pay for
# using the script. If you don't want this info and you don't want to pay
# for it, then write your own damn script.
 putserv "PRIVMSG $skool(chan) :SKooL $skool(ver) by David Proper (DrN)"
 putserv "PRIVMSG $skool(chan) :Copyright 2002 Radical Computer Systems - All Rights Reserved"
 putserv "PRIVMSG $skool(chan) :http://www.chaotix.net/rcs"
 return 0
                                             }
 incr skool_lesson(cur) 1
 set line $skool_lesson($skool_lesson(cur))
 set cmd [string index $line 0]
 set line [string range $line 1 end]

 regsub -all {%channel%} $line $chan line
 regsub -all {%nick%} $line $skool(started) line
 regsub -all {%topic%} $line $skool(topic) line

 switch $cmd {
  "W" {wallops $chan $line}
  "P" {set delay $line}
  "M" {putserv "MODE $chan $line"}
  "!" {set skool(tag) $line}
  " " {if {$skool(tag) == ""} {skool_out $chan $chan $line
                             } else {
                              skool_out $chan $chan "$line \($skool(tag)\)"
                                    }
       set skool(tag) ""}
  "T" {putserv "TOPIC $chan :$line"}
             }
 set skool(timer) [utimer $delay skool_teach]

}

proc skool_load {chan nick rest} {
global skool skool_lesson
 set df [lindex $rest 0]
 if {$df == ""} {skool_out $nick $chan "Calling Syntax: [cmdchar]skool load lessonfile"; return 0}
 if {$skool(run) == 1} {skool_out $chan $nick "There is currently a lesson running. Loading new data would fuck shit up."; return 0}
 if {![file exists $skool(data)$df]} {
  skool_out $nick $chan "I can't find $skool(data)$df"; return 0
                        }
if {[info exists skool_lesson]} {unset skool_lesson}
set skool_lesson(max) 0
set skool_lesson(cur) 0
set skool(topic) ""

 set in [open $skool(data)$df r]
 while {![eof $in]} {
 set line [gets $in]
 set cmd [string index $line 0]
 set saveit 1
 if {$line == ""} {set saveit 0}
 if {$cmd == ";"} {set saveit 0}
 if {$cmd == "="} {
                   set saveit 0
                   set skool(topic) [string range $line 1 end]
                  }
 if {$saveit == 1} {
  incr skool_lesson(max) 1
  set skool_lesson($skool_lesson(max)) "$line"
                   }
                    }
 close $in
skool_out $nick $chan "Loaded: $skool(topic)   $skool_lesson(max) lines read."
set skool(load) 1
}

# isnumber taken from alltools.tcl
proc isnum {string} {
  if {([string compare $string ""]) && (![regexp \[^0-9\] $string])} then {return 1}
  return 0
}

proc wallops {chan msg} {
    foreach user1 [chanlist $chan] {
     set hand [nick2hand $user1 $chan]
     if {![onchansplit $user1 $chan] && ([isop $user1 $chan] || ([matchattr $hand o]))} {
      set oplist $user1
      putserv "NOTICE $oplist :(\002OPmsg\002/$chan) $msg"
      unset oplist
                                                             }
                                   }
}


proc skool_out {nick channel txt} {
global skool
 regsub -all {!PD!} $txt \. txt
 regsub -all {!CO!} $txt \: txt
 regsub -all {!SQ!} $txt \' txt
 regsub -all {!QL!} $txt \; txt
 regsub -all {!QT!} $txt \" txt
 regsub -all {!LT!} $txt \< txt
 regsub -all {!GT!} $txt \> txt
 regsub -all {!LP!} $txt \( txt
 regsub -all {!RP!} $txt \) txt
 regsub -all {!LB!} $txt \{ txt
 regsub -all {!RB!} $txt \} txt
 regsub -all {!LF!} $txt \[ txt
 regsub -all {!RF!} $txt \] txt
 regsub -all {!SL!} $txt \\ txt
# if {$lookup(public)==2} {set channel $nick}
 if {[isnum $nick]} {putidx $nick "$txt"
                    } else {
                            puthelp "PRIVMSG $channel :$txt"
                           }
# if {$dirc == "1"} { putserv "PRIVMSG $channel :$txt" }
# if {$dirc == "2"} { putserv "PRIVMSG $nick :$txt" }
# if {$dirc == "3"} { putserv "NOTICE $nick :$txt" }
# if {$dirc == "4"} { putdcc $nick "$txt" }
}

putlog "SKooL $skool(ver) by David Proper (DrN) -: LoadeD :-"
return "SKooL $skool(ver) by David Proper (DrN) -: LoadeD :-"

